#ifndef AREA_TRANSFER_HPP
#define AREA_TRANSFER_HPP

#include "character_unit.hpp"
#include <godot_cpp/templates/hash_set.hpp>
#include <godot_cpp/classes/area3d.hpp>

namespace gd = godot;

class AreaTransfer : public gd::Area3D {
    GDCLASS(AreaTransfer, gd::Area3D);
    static void _bind_methods();
public:
    virtual void _ready() override;
    void _on_body_entered(gd::Node3D *body);
    void _on_body_exited(gd::Node3D *body);
    void check_all_ready();
    void set_next_scene(gd::String path);
    gd::String get_next_scene() const;
private:
    gd::String next_scene{};
    gd::HashSet<CharacterUnit *> ready_units{};
};

#endif // !AREA_TRANSFER_HPP
